#include <iostream>  // input and output functions, like cout, cin 
using namespace std; // so we don't have to prepend std::<bleh> on everything

// This is the C++ way to define a constant
const int upper_limit = 100; // we're going to stop the user from entering things bigger than this.
// This is the older C way to define a constant(NB: this is done via the preprocessor)
// #define UPPER_LIMIT 100

// v---- that is the return type.
float abs_value(float n)
{
	if (n >= 0) 
		return n;
	return -n;
}

bool is_pos(int x)
{	
	/*	
  		if (x > 0) 
		return true;
	return false;	
	*/
	cout << "Checking positiveness." << endl;
	return (x > 0);
}

bool is_even(int x)
{
	cout << "Checking evenness." << endl;
	return ((x % 2) == 0);
}


bool handy_checker(bool f, bool s)
{
	return (f && s);
}



int main()  // function were execution begins
{
	/*
  	You can split things in different places with the stream operator. To wit:	
		cout << "Hello," << " wor" << "ld!" << endl; 
	*/	

	/*	 below this was some testing with floating points.
	int num;
	cout << "Input a number please (make it less than " << upper_limit << "): ";
	cin >> num;
	//int twice_limit = upper_limit * 2;
	//int twice_limit = 100 * 2;           The point of these lines is to see what the compiler 
	//					does if we try to change a constant.
	
	if (num >= upper_limit)
	{
		cout << "No, that's too big!" << endl;
		return 1; // return an error.
	}
	cout << "The number is " << num << " thank you!" << endl;

	float my_float = abs_value(num/3.14);

	cout << "My floating point number is = " << my_float << endl;

	*/

	/* This shows properties of evaluation, short-circuiting, etc.
*/

	int num;
	cout << "Input a number please:" << endl;
	cin >> num;
	
	// These, superficially, look like they do the same thing. But don't!
//	if ((is_even(num)) && (is_pos(num)))
	if (handy_checker(is_even(num), is_pos(num)))
	{
		cout << "Victory! Both positive and even. Yaay." << endl;
	}
	else
	{
		cout << "Nope." << endl;
	}





	return 0; // returning zero from main() indicates success
}




